data TimeSeriesTree;
  length Name $3 Label $13;
  format Date x xo xl xh xlabel date9.;
  format Cost percent.;
  retain id 1;
  x=.; y=.; xo=.; yo=.;
  do date='01Jan2000'd, '01Feb2000'd, '01Mar2000'd, '01Apr2000'd,
      '01May2000'd, '01Jun2000'd, '01Jul2000'd, '01Aug2000'd,
      '01Sep2000'd, '01Oct2000'd, '01Nov2000'd, '01Dec2000'd;
    Cost=0.05;
    Size=1;
    Name=' ';
    output;
    id = id + 1;
  end;

  /* Each non-leaf node is generated. Its left and right links are created as an
   * inverted U with 3 segments.
   */
  id=13; name='1'; date='16Mar2000'd; cost=0.20;
  output;
  id=.;  name='V1'; x='01Mar2000'd; y=0.2; xo=x; yo=0.05; cost=.;
  output;
  id=.;  name='V2'; x='01Apr2000'd; y=0.2; xo=x; yo=0.05; cost=.;
  output;
  id=.;  name='V3'; x='01Mar2000'd; y=0.2; xo='01Apr2000'd; yo=0.2; cost=.;
  output;

  id=14; name='2'; date='16Aug2000'd; cost=0.25; output;
  id=.;  name='V4'; x='01Aug2000'd; y=0.25; xo=x; yo=0.05; cost=.; output;
  id=.;  name='V5'; x='01Sep2000'd; y=0.25; xo=x; yo=0.05; cost=.; output;
  id=.;  name='V6'; x='01Aug2000'd; y=0.25; xo='01Sep2000'd; yo=0.25; cost=.; output;

  id=16; name='3'; date='16May2000'd; cost=0.30; output;
  id=.;  name='V7'; x='01May2000'd; y=0.30; xo=x; yo=0.05; cost=.; output;
  id=.;  name='V8'; x='01Jun2000'd; y=0.30; xo=x; yo=0.05; cost=.; output;
  id=.;  name='V9'; x='01May2000'd; y=0.30; xo='01Jun2000'd; yo=0.30; cost=.; output;

  id=17; name='4'; date='10Sep2000'd; cost=0.40; output;
  id=.;  name='V10'; x='16Aug2000'd; y=0.25; xo=x; yo=0.4; cost=.; output;
  id=.;  name='V11'; x='01Oct2000'd; y=0.05; xo=x; yo=0.4; cost=.; output;
  id=.;  name='V12'; x='16Aug2000'd; y=0.40; xo='01Oct2000'd; yo=0.40; cost=.; output;

  id=18; name='5'; date='22Feb2000'd; cost=0.50; output;
  id=.;  name='V13'; x='01Feb2000'd; y=0.05; xo=x; yo=0.5; cost=.; output;
  id=.;  name='V14'; x='16Mar2000'd; y=0.20; xo=x; yo=0.5; cost=.; output;
  id=.;  name='V15'; x='01Feb2000'd; y=0.50; xo='16Mar2000'd; yo=0.50; cost=.; output;

  id=19; name='6'; date='25Jan2000'd; cost=0.60; output;
  id=.;  name='V16'; x='01Jan2000'd; y=0.05; xo=x; yo=0.6; cost=.; output;
  id=.;  name='V17'; x='22Feb2000'd; y=0.50; xo=x; yo=0.6; cost=.; output;
  id=.;  name='V18'; x='01Jan2000'd; y=0.60; xo='22Feb2000'd; yo=0.60; cost=.; output;

  id=20; name='7'; date='16Nov2000'd; cost=0.80; output;
  id=.;  name='V19'; x='01Nov2000'd; y=0.05; xo=x; yo=0.8; cost=.; output;
  id=.;  name='V20'; x='01Dec2000'd; y=0.05; xo=x; yo=0.8; cost=.; output;
  id=.;  name='V21'; x='01Nov2000'd; y=0.80; xo='01Dec2000'd; yo=0.80; cost=.; output;

  id=21; name='8'; date='10Jun2000'd; cost=0.90; output;
  id=.;  name='V22'; x='16May2000'd; y=0.30; xo=x; yo=0.9; cost=.; output;
  id=.;  name='V23'; x='01Jul2000'd; y=0.05; xo=x; yo=0.9; cost=.; output;
  id=.;  name='V24'; x='16May2000'd; y=0.90; xo='01Jul2000'd; yo=0.90; cost=.; output;

  /* Left and right extents for double-ended arrows */
  id=.; y2=1.05; xl='01Jan2000'd; xh='10Apr2000'd;
  label='Segment One'; xlabel=(xl+xh)/2; /* Label for arrows */
  output;

  id=.; y2=1.05; xl='20Apr2000'd; xh='10Jul2000'd;
  label='Segment Two'; xlabel=(xl+xh)/2; output;
  id=.; y2=1.05; xl='20Jul2000'd; xh='10Oct2000'd;
  label='Segment Three'; xlabel=(xl+xh)/2; output;
  id=.; y2=1.05; xl='20Oct2000'd; xh='01Dec2000'd;
  label='Segment Four'; xlabel=(xl+xh)/2; output;

  run;

data regimes;
  input date2 regime;
  informat date2 date.;
  format date2 date.;
  datalines;
'01Jan2000'd  1
'15Apr2000'd  1
'15Apr2000'd  2
'15Jul2000'd  2
'15Jul2000'd  3
'15Oct2000'd  3
'15Oct2000'd  4
'01Dec2000'd  4
;
run;

data merged;
  set timeseriestree regimes;
  run;
/*proc print;run;*/

proc template;
   define style styles.TimeSeriesTree;
      parent = Styles.listing;

    style color_list from color_list
       "Abstract colors used in graph styles" /
     'bgA'   = cxd0d7df;

      style GraphColors from GraphColors /
         'gcdata' =cx000000
     'gdata'  =cxf3f7ff;
   end;
run;

proc template;
  define statgraph TimeSeriesSegTree;
    begingraph;
      entrytitle 'Time Series Segmentation Graph for 2000';
      layout overlay / xaxisopts=(label='Time' offsetmax=0.05 offsetmin=0.05 display=(ticks tickvalues) 
                                 timeopts=(splittickvalue=false interval=month tickvalueformat=monname3.))
                       yaxisopts=(label='Cost' linearopts=(viewmin=0 tickvalueformat=percent.));
        blockplot x=date2 block=regime / filltype=alternate  altfillattrs=(color=white) datatransparency=0.3 display=(fill);
        vectorplot x=x y=y xorigin=xo yorigin=yo / arrowheads=false;
        bubbleplot x=date y=cost size=size / bubbleradiusmin=12px dataskin=sheen fillattrs=graphdata1;
        scatterplot x=date y=cost / markercharacter=name;
        highlowplot y=y2 low=xl high=xh / type=bar highcap=filledarrow lowcap=filledarrow 
                    intervalbarwidth=11 fillattrs=graphdata1 datatransparency=0.5;
        scatterplot y=y2 x=xlabel/ markercharacter=label markercharacterattrs=(size=5);
    endlayout;
  endgraph;
  end;
run;
ods html style=styles.TimeSeriesTree;
ods graphics / reset imagename='TimeSeriesSegTree';
proc sgrender data=merged template=TimeSeriesSegTree;
  format date month.;
run;
